task starfusion{
    String sample_id
    File fastq1
    File fastq2
    File database_dir
	
    String docker
    String cluster
    String disk_size

    command <<<
	
        set -o pipefail
        set -e

        mkdir -p ${sample_id}/output

        STAR-Fusion --genome_lib_dir ${database_dir} \
            --left_fq ${fastq1} \
            --right_fq ${fastq2} \
            --CPU 16 \
            --output_dir  ${sample_id}/output \
            --FusionInspector validate \
            --examine_coding_effect

        mv  ${sample_id}/output/star-fusion.fusion_predictions.tsv ${sample_id}/output/${sample_id}_star-fusion.fusion_predictions.tsv
        mv  ${sample_id}/output/star-fusion.fusion_predictions.abridged.tsv ${sample_id}/output/${sample_id}_star-fusion.fusion_predictions.abridged.tsv
        mv  ${sample_id}/output/star-fusion.fusion_predictions.abridged.coding_effect.tsv ${sample_id}/output/${sample_id}_star-fusion.fusion_predictions.abridged.coding_effect.tsv
       
        cp  ${sample_id}/output/FusionInspector-validate/finspector.FusionInspector.fusions.tsv ${sample_id}/output/${sample_id}_finspector.FusionInspector.fusions.tsv
        cp  ${sample_id}/output/FusionInspector-validate/finspector.FusionInspector.fusions.abridged.tsv ${sample_id}/output/${sample_id}_finspector.FusionInspector.fusions.abridged.tsv
        cp  ${sample_id}/output/FusionInspector-validate/finspector.FusionInspector.fusions.abridged.tsv.annotated ${sample_id}/output/${sample_id}_finspector.FusionInspector.fusions.abridged.tsv.annotated
        cp  ${sample_id}/output/FusionInspector-validate/finspector.FusionInspector.fusions.abridged.tsv.annotated.coding_effect ${sample_id}/output/${sample_id}_finspector.FusionInspector.fusions.abridged.tsv.annotated.coding_effect
        cp  ${sample_id}/output/FusionInspector-validate/finspector.fusion_inspector_web.html ${sample_id}/output/${sample_id}_finspector.fusion_inspector_web.html
        tar -zcvf ${sample_id}/output/${sample_id}_FusionInspector-validate.tgz ${sample_id}/output/FusionInspector-validate

    >>>
	
    runtime {
        docker : docker
        cluster: cluster
        systemDisk: "cloud_ssd 40"
        dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"
    }

    output {
        Array[File] starfusion_result=glob("${sample_id}/output/${sample_id}_star-fusion*")
        Array[File] finspector_result=glob("${sample_id}/output/${sample_id}_finspector*")
        Array[File] starfusion_out=glob("${sample_id}/output/*.out")
        Array[File] starfusion_tgz=glob("${sample_id}/output/*.tgz")
    }

}


